%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File: stack.oz
% Purpose: implements stack behavior
% Date: 2000 11 20
% Written by: Per Brand and Sameh ElAnsary
% Modified by: Mahmoud Rafea
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
functor
import
   Browser
   
export
   showStack:ShowStack
   pop:Pop
   push:Push
   top:Top
   pointer:Pointer
   entries:Entries
   new:New
   isEmpty:IsEmpty
   
define
   
   proc {ShowStack Stack}
      {Browser.browse {Dictionary.items Stack.dict}}
   end
   
   proc {New S}
      S =d(dict:{Dictionary.new} pointer:{NewCell 0 $})
   end

%%%   {Dictionary.put Dict Key Elem}
   proc{Push Stack Elem}
      Old New in
      {Exchange Stack.pointer Old New}
      {Dictionary.put Stack.dict Old Elem}
      New=Old+1
   end

%%%   {Dictionary.get Dict Key ?Elem}
   proc{Pop Stack ?Elem}
      Old New in
      {Exchange Stack.pointer Old New}
      {Dictionary.get Stack.dict Old-1 Elem}
      {Dictionary.remove Stack.dict Old-1}
      New = Old - 1
   end

   fun {Top Stack}
      {Dictionary.get Stack.dict {Access Stack.pointer}-1}
   end

   fun {Pointer Stack}
      {Access Stack.pointer}
   end

%%%   {Dictionary.entries Dict ?Entries}
   fun {Entries Stack}
      E in
      {Dictionary.entries Stack.dict E}
      {List.sort E fun{$ KX#_ KY#_} KX > KY end}
   end

   proc{IsEmpty Stack ?B}
      B = {List.length {Dictionary.keys Stack.dict}} == 0
   end

end
